## olsrd-0.9.8 p20241102

=== Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

# Please also write a new version to:
# gui/win32/Main/Frontend.rc (line 71, around "CAPTION [...]")
# gui/win32/Inst/installer.nsi (line 57, around "MessageBox MB_YESNO [...]")
VERS =		pre-0.9.9

TOPDIR = $(shell pwd)
INSTALLOVERWRITE ?=
include Makefile.inc

# pass generated variables to save time
MAKECMD = $(MAKE) OS="$(OS)" WARNINGS="$(WARNINGS)" VERBOSE="$(VERBOSE)" SANITIZE_ADDRESS="$(SANITIZE_ADDRESS)"

LIBS +=		$(OS_LIB_DYNLOAD)
ifeq ($(OS), win32)
LDFLAGS +=	-Wl,--out-implib=libolsrd.a
LDFLAGS +=	-Wl,--export-all-symbols
endif

SWITCHDIR =	src/olsr_switch
CFGDIR =	src/cfgparser
include $(CFGDIR)/local.mk
TAG_SRCS =	$(SRCS) $(HDRS) $(sort $(wildcard $(CFGDIR)/*.[ch] $(SWITCHDIR)/*.[ch]))

SGW_SUPPORT = 0
ifeq ($(OS),linux)
  SGW_SUPPORT = 1
endif
ifeq ($(OS),android)
  SGW_SUPPORT = 1
endif


.PHONY: default_target switch
default_target: $(EXENAME)

ANDROIDREGEX=
ifeq ($(OS),android)
# On Android Google forgot to include regex engine code for Froyo version (but also there was
# no support in older versions for it) so we have here this missing code.
# http://groups.google.com/group/android-ndk/browse_thread/thread/5ea6f0650f0e3fc
CFLAGS += -D__POSIX_VISIBLE
ANDROIDREGEX=$(REGEX_LIB)
endif

$(EXENAME):	$(OBJS) $(ANDROIDREGEX) src/builddata.o
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -lm -o $@ $^ $(LIBS)

cfgparser:	$(CFGDEPS) src/builddata.o
		$(MAKECMDPREFIX)$(MAKECMD) -C $(CFGDIR)

switch:		
	$(MAKECMDPREFIX)$(MAKECMD) -C $(SWITCHDIR)

# generate it always
.PHONY: builddata.txt
builddata.txt:
	$(MAKECMDPREFIX)./make/hash_source.sh "$@" "$(VERS)" "$(VERBOSE)"

# only overwrite it when it doesn't exists or when it has changed
src/builddata.c: builddata.txt
	$(MAKECMDPREFIX)if [ ! -f "$@" ] || [ -n "$$(diff "$<" "$@")" ]; then cp -p "$<" "$@"; fi

.PHONY: help libs clean_libs libs_clean clean distclean uberclean install_libs uninstall_libs libs_install libs_uninstall install_bin uninstall_bin install_olsrd uninstall_olsrd install uninstall build_all install_all uninstall_all clean_all gui clean_gui cfgparser_install cfgparser_clean

clean:
	-rm -f $(OBJS) $(SRCS:%.c=%.d) $(EXENAME) $(EXENAME).exe src/builddata.c $(TMPFILES)
	-rm -f libolsrd.a
	-rm -f olsr_switch.exe
	-rm -f gui/win32/Main/olsrd_cfgparser.lib
	-rm -f olsr-setup.exe
	-rm -fr gui/win32/Main/Release
	-rm -fr gui/win32/Shim/Release

gui:
ifeq ($(OS),linux)
	$(MAKECMDPREFIX)$(MAKECMD) -C gui/linux-gtk all
else
	@echo "target gui not supported on $(OS)"
	@exit 1
endif

clean_gui:
	$(MAKECMDPREFIX)$(MAKECMD) -C gui/linux-gtk clean

distclean: uberclean
uberclean:	clean clean_libs clean_gui
	-rm -f $(TAGFILE)
#	BSD-xargs has no "--no-run-if-empty" aka "-r"
	find . \( -name '*.[od]' -o -name '*~' \) -not -path "*/.hg*" -type f -print0 | xargs -0 rm -f
	$(MAKECMDPREFIX)$(MAKECMD) -C $(SWITCHDIR) clean
	$(MAKECMDPREFIX)$(MAKECMD) -C $(CFGDIR) clean
	$(MAKECMDPREFIX)rm -f builddata.txt

install: install_olsrd

uninstall: uninstall_olsrd

cfgparser_install: cfgparser
		$(MAKECMDPREFIX)$(MAKECMD) -C $(CFGDIR) install

cfgparser_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C $(CFGDIR) clean

install_bin:
		mkdir -p $(SBINDIR)
		install -m 755 $(EXENAME) $(SBINDIR)
		$(STRIP) $(SBINDIR)/$(EXENAME)
ifeq ($(SGW_SUPPORT),1)
		$(MAKECMDPREFIX)if [ -e $(SBINDIR)/$(SGW_POLICY_SCRIPT) ]; then \
			cp -f files/$(SGW_POLICY_SCRIPT) $(SBINDIR)/$(SGW_POLICY_SCRIPT).new; \
			echo "Policy routing script was saved as $(SBINDIR)/$(SGW_POLICY_SCRIPT).new"; \
		else \
			cp -f files/$(SGW_POLICY_SCRIPT) $(SBINDIR)/$(SGW_POLICY_SCRIPT); \
		fi
endif

uninstall_bin:
		rm -f $(SBINDIR)/$(EXENAME)
		rmdir -p $(SBINDIR) || true

install_olsrd:	install_bin
		@echo ========= C O N F I G U R A T I O N - F I L E ============
		@echo $(EXENAME) uses the configfile $(CFGFILE)
		@echo a default configfile. A sample RFC-compliance aimed
		@echo configfile can be found in olsrd.conf.default.rfc.
		@echo However none of the larger OLSRD using networks use that
		@echo so install a configfile with activated link quality exstensions
		@echo per default.
		@echo can be found at files/olsrd.conf.default.lq
		@echo ==========================================================
		mkdir -p $(ETCDIR)
		$(MAKECMDPREFIX)if [ -e $(CFGFILE) ]; then \
			cp -f files/olsrd.conf.default.lq $(CFGFILE).new; \
			echo "Configuration file was saved as $(CFGFILE).new"; \
		else \
			cp -f files/olsrd.conf.default.lq $(CFGFILE); \
		fi
		@echo -------------------------------------------
		@echo Edit $(CFGFILE) before running olsrd!!
		@echo -------------------------------------------
		@echo Installing manpages $(EXENAME)\(8\) and $(CFGNAME)\(5\)
ifneq ($(MANDIR),)
		mkdir -p $(MANDIR)/man8/
		cp files/olsrd.8.gz $(MANDIR)/man8/$(EXENAME).8.gz
		mkdir -p $(MANDIR)/man5/
		cp files/olsrd.conf.5.gz $(MANDIR)/man5/$(CFGNAME).5.gz
endif
ifneq ($(RCDIR),)
		cp $(RCFILE) $(RCDIR)/olsrd
endif
ifneq ($(DOCDIR_OLSRD),)
		mkdir -p "$(DOCDIR_OLSRD)"
		cp -t "$(DOCDIR_OLSRD)" "CHANGELOG" "README-Olsr-Extensions" \
		  "README-LINUX_NL80211.txt" "files/olsrd.conf.default" \
		  "files/olsrd.conf.default.txt" "license.txt"
endif

uninstall_olsrd:	uninstall_bin
ifneq ($(DOCDIR_OLSRD),)
		rm -f "$(DOCDIR_OLSRD)/CHANGELOG" "$(DOCDIR_OLSRD)/README-Olsr-Extensions" \
		  "$(DOCDIR_OLSRD)/README-LINUX_NL80211.txt" "$(DOCDIR_OLSRD)/olsrd.conf.default" \
		  "$(DOCDIR_OLSRD)/olsrd.conf.default.txt" "$(DOCDIR_OLSRD)/license.txt"
		rmdir -p --ignore-fail-on-non-empty "$(DOCDIR_OLSRD)"
endif
ifneq ($(MANDIR),)
		rm -f $(MANDIR)/man5/$(CFGNAME).5.gz
		rmdir -p $(MANDIR)/man5/ || true
		rm -f $(MANDIR)/man8/$(EXENAME).8.gz
		rmdir -p $(MANDIR)/man8/ || true
endif
		rm -f $(CFGFILE) $(CFGFILE).new
		rmdir -p $(ETCDIR) || true
ifneq ($(RCDIR),)
		rm -f $(RCDIR)/olsrd
		rmdir -p $(RCDIR) || true
endif

tags:
		$(TAGCMD) -o $(TAGFILE) $(TAG_SRCS)

rpm:
	$(MAKECMDPREFIX)$(MAKECMD) -C redhat


#
# PLUGINS
#

# This is quite ugly but at least it works
ifeq ($(OS),linux)
SUBDIRS := arprefresh bmf dot_draw dyn_gw dyn_gw_plain filtergw httpinfo info jsoninfo mdns mini nameservice netjson poprouting p2pd pgraph pud quagga secure sgwdynspeed txtinfo watchdog
else
ifeq ($(OS),win32)
SUBDIRS := dot_draw httpinfo info jsoninfo mini netjson pgraph secure txtinfo
else
ifeq ($(OS),android)
SUBDIRS := arprefresh bmf dot_draw dyn_gw dyn_gw_plain httpinfo info jsoninfo mdns mini nameservice netjson p2pd pgraph secure sgwdynspeed txtinfo watchdog
else
SUBDIRS := dot_draw httpinfo info jsoninfo mini nameservice netjson pgraph secure txtinfo watchdog
endif
endif
endif

libs:
		$(MAKECMDPREFIX)set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR);done

libs_clean clean_libs:
		-for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) clean;rm -f lib/$$dir/*.so lib/$$dir/*.dll;done

libs_install install_libs:
		$(MAKECMDPREFIX)set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) install;done

libs_uninstall uninstall_libs:
		$(MAKECMDPREFIX)set -e;for dir in $(SUBDIRS);do $(MAKECMD) -C lib/$$dir LIBDIR=$(LIBDIR) uninstall;done
		rmdir -p $(LIBDIR) || true

#
# DOCUMENTATION
#
.PHONY: doc doc_clean
doc:
		$(MAKECMDPREFIX)$(MAKECMD) -C doc OS=$(OS)

doc-pdf:
		$(MAKECMDPREFIX)$(MAKECMD) -C doc-pdf OS=$(OS)

doc_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C doc OS=$(OS) clean

#
# PLUGINS
#

arprefresh:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/arprefresh

arprefresh_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) clean

arprefresh_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) install

arprefresh_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/arprefresh DESTDIR=$(DESTDIR) uninstall

bmf:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/bmf

bmf_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) clean

bmf_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) install

bmf_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) uninstall

dot_draw:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dot_draw

dot_draw_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) clean

dot_draw_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) install

dot_draw_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) uninstall

dyn_gw:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw

dyn_gw_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) clean

dyn_gw_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) install

dyn_gw_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) uninstall

dyn_gw_plain:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw_plain

dyn_gw_plain_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) clean

dyn_gw_plain_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) install

dyn_gw_plain_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) uninstall

filtergw:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/filtergw

filtergw_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/filtergw DESTDIR=$(DESTDIR) clean

filtergw_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/filtergw DESTDIR=$(DESTDIR) install

filtergw_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/filtergw DESTDIR=$(DESTDIR) uninstall

httpinfo:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/httpinfo

httpinfo_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) clean

httpinfo_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) install

httpinfo_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) uninstall

info:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/info

info_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/info DESTDIR=$(DESTDIR) clean

info_install:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/info DESTDIR=$(DESTDIR) install

info_uninstall:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/info DESTDIR=$(DESTDIR) uninstall

info_java:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/info.java

info_java_clean:
		$(MAKECMDPREFIX)$(MAKECMD) -C lib/info.java DESTDIR=$(DESTDIR) clean

=== doc/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

TOPDIR = ..
include $(TOPDIR)/Makefile.inc

HTML_DIR = html
HTML_OUTPUT = $(HTML_DIR)/$(OS)

LATEX_DIR = latex
LATEX_OUTPUT = $(LATEX_DIR)/$(OS)

PDF_DIR = pdf
PDF_OUTPUT = $(PDF_DIR)/olsrd_$(OS).pdf

DOX_FILE = doxygen.conf
TMP_DOX_FILE = $(DOX_FILE).temp

OLSRD_VER = $(shell git describe --dirty --always)


DOC_DEFINES = $(shell ./getdefines.bash $(CPPFLAGS) $(CFLAGS))


# All excludes
# DOC_INPUT   = ../src ../android
# DOC_EXCLUDE = ../src/linux ../src/unix ../android ../src/win32 ../src/bsd

DOC_INPUT   = ../src ../android

ifeq ($(OS), linux)
DOC_DEFINES += __linux__
DOC_EXCLUDE = ../android ../src/win32 ../src/bsd
else
ifeq ($(OS), android)
DOC_DEFINES += __linux__ _ANDROID
DOC_EXCLUDE = ../src/win32 ../src/bsd
else
ifeq ($(OS), win32)
DOC_DEFINES += _WIN32
DOC_EXCLUDE = ../src/linux ../src/unix ../android ../src/bsd
else
$(error $(OS) not known to the doc makefile)
endif
endif
endif


all: default_target

default_target: doc

.PHONY: .gitignore doc doc-pdf clean

clean:
	@echo "[$@] doc"
	@rm -fr "$(HTML_DIR)" "$(LATEX_DIR)" "$(PDF_DIR)" "$(TMP_DOX_FILE)"

doc: $(DOX_FILE)
	@echo "[$@] doc"
	@echo "  Cleaning up $(OS) outputs..."
	@rm -fr "$(HTML_OUTPUT)" "$(LATEX_OUTPUT)"
	@mkdir -pv "$(HTML_OUTPUT)"
	@mkdir -pv "$(LATEX_OUTPUT)"
	@echo "  Generating doxygen configuration..."
	@sed \
	  -e "s/__OLSRD_VER__/$(OLSRD_VER)/" \
	  -e "s#__OLSRD_NAME__#olsrd ($(OS))#" \
	  -e "s#__DEFINES__#$(DOC_DEFINES)#" \
	  -e "s#__INPUT__#$(DOC_INPUT)#" \
	  -e "s#__EXCLUDE__#$(DOC_EXCLUDE)#" \
	  -e "s#__HTML_OUTPUT__#$(HTML_OUTPUT)#" \
	  -e "s#__LATEX_OUTPUT__#$(LATEX_OUTPUT)#" \
	  "$(DOX_FILE)" > "$(TMP_DOX_FILE)"
	@echo "  Running doxygen to create HTML..."
	@doxygen "$(TMP_DOX_FILE)"
	@rm -f "$(TMP_DOX_FILE)"
	@echo "  Done"

doc-pdf: doc
	@echo "[$@] doc"
	@echo "  Cleaning up $(OS) outputs..."
	@rm -fr "$(PDF_OUTPUT)"
	@mkdir -pv "$(PDF_DIR)"
	@echo "  Running latex to create a PDF..."
	@$(MAKE) -s -C $(LATEX_OUTPUT) all
	@mkdir -pv "$(PDF_DIR)"
	@mv -v "$(LATEX_OUTPUT)/refman.pdf" "$(PDF_OUTPUT)"
	@rm -fr "$(LATEX_OUTPUT)"
	@rmdir -v --ignore-fail-on-non-empty "$(LATEX_DIR)"
	@echo "  Done"

=== redhat/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

TOPDIR = ..
include $(TOPDIR)/Makefile.inc

RUNNER = ./runner

MOCKCFG ?=


.PHONY: all check clean prepare build
default_target: all

all: check
ifeq ($(MOCKCFG),)
	$(RUNNER) all
else
	$(RUNNER) all $(MOCKCFG)
endif

clean: check
	$(RUNNER) clean

prepare: check
	$(RUNNER) prepare

build: check
ifeq ($(MOCKCFG),)
	$(RUNNER) build
else
	$(RUNNER) build $(MOCKCFG)
endif

check:
ifneq ($(OS),linux)
	$(error Can only build an RPM on Linux.)
endif

=== android/regex/Makefile ===
SRC = regcomp.c regerror.c regexec.c regfree.c 
OBJ = $(SRC:.c=.o)
INCLUDES = -I. -I..

CFLAGS := -O2 -D_FORTIFY_SOURCE=2
CFLAGS += -fPIC

all: $(REGEX_LIB)

%.o: %.c
ifeq ($(VERBOSE),0)
	@echo "[CC] $<"
endif
	$(MAKECMDPREFIX)$(CC) $(INCLUDES) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

$(REGEX_LIB): $(OBJ)
ifeq ($(VERBOSE),0)
	@echo "[AR] $<"
endif
	$(MAKECMDPREFIX)$(AR) rcs $(REGEX_LIB) $(OBJ)

clean:
	rm -f $(OBJ) $(REGEX_LIB)

=== contrib/netsimpcap/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

SRC +=	$(sort $(wildcard ./src/*.c))

OBJS = $(SRC:.c=.o)

CC = gcc
CFLAGS = -c -g -Wall -Werror -I./src -I../../src
LFLAGS = -g -Wall 
BUILDLIBS = -lpcap

.c.o:
	${CC} ${CFLAGS} -o $@ $^

netsimpcap:	${OBJS}
	${CC} -o ./bin/$@ ${LFLAGS} ${BUILDLIBS} ${OBJS}

clean:
	rm -f ${OBJS} ./bin/netsimpcap

all: netsimpcap

=== gui/linux-gtk/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

TOPDIR ?= ../..
include $(TOPDIR)/Makefile.inc

# hardening flags: -fPIE -Wl,-z,now -pie
CFLAGS += $(shell pkg-config --cflags gtk+-2.0) -fPIE -Wno-strict-prototypes \
          -Wno-cast-qual
CPPFLAGS += $(shell pkg-config --cflags gtk+-2.0)
LDFLAGS += -pie
#LDFLAGS +=	-Wl,--warn-common


LIBS := $(shell pkg-config --libs gtk+-2.0) -lm

# 32/64 cross compilation
ifdef M32
CFLAGS +=	-m32
LDFLAGS +=	-m32
endif
ifdef M64
CFLAGS +=	-m64
LDFLAGS +=	-m64
endif


all: default_target

default_target: olsrd-gui

olsrd-gui:	$(OBJS)
ifeq ($(VERBOSE),0)
	@echo "[LD] $@"
endif
	$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)

.PHONY: clean install

clean:
	rm -f $(OBJS) olsrd-gui

install:
	mkdir -p "$(DESTDIR)/usr/bin"
	cp ./olsrd-gui "$(DESTDIR)/usr/bin/"

=== lib/arprefresh/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_arprefresh
PLUGIN_VER =	0.1

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)
ifneq ($(DOCDIR_OLSRD),)
		mkdir -p "$(DOCDIR_OLSRD)"
		cp "README_ARPREFRESH" "$(DOCDIR_OLSRD)"
endif

uninstall:
ifneq ($(DOCDIR_OLSRD),)
		rm -f "$(DOCDIR_OLSRD)/README_ARPREFRESH"
		rmdir -p --ignore-fail-on-non-empty "$(DOCDIR_OLSRD)"
endif
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== lib/bmf/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_bmf
PLUGIN_VER =	1.7.0

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

ifeq ($(OS),$(filter $(OS),linux android))

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)
ifneq ($(DOCDIR_OLSRD),)
		mkdir -p "$(DOCDIR_OLSRD)"
		cp "README_BMF" "$(DOCDIR_OLSRD)"
endif

uninstall:
ifneq ($(DOCDIR_OLSRD),)
		rm -f "$(DOCDIR_OLSRD)/README_BMF"
		rmdir -p --ignore-fail-on-non-empty "$(DOCDIR_OLSRD)"
endif
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

else

default_target install clean: 
	@echo "*** BMF Plugin only supported on Linux and Android, sorry!"

endif

=== lib/dot_draw/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_dot_draw
PLUGIN_VER =	0.3

TOPDIR =	../..
include $(TOPDIR)/Makefile.inc

LDFLAGS += -lm

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)
ifneq ($(DOCDIR_OLSRD),)
		mkdir -p "$(DOCDIR_OLSRD)"
		cp -t "$(DOCDIR_OLSRD)" "README_DOT_DRAW" "olsr-topology-view.pl"
endif

uninstall:
ifneq ($(DOCDIR_OLSRD),)
		rm -f "$(DOCDIR_OLSRD)/README_DOT_DRAW" "$(DOCDIR_OLSRD)/olsr-topology-view.pl"
		rmdir -p --ignore-fail-on-non-empty "$(DOCDIR_OLSRD)"
endif
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== lib/dyn_gw/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_dyn_gw
PLUGIN_VER =	0.5

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

LIBS +=	$(OS_LIB_PTHREAD)

# Must be specified along with -lpthread on linux
CPPFLAGS += $(OS_CFLAG_PTHREAD)

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)
ifneq ($(DOCDIR_OLSRD),)
		mkdir -p "$(DOCDIR_OLSRD)"
		cp "README_DYN_GW" "$(DOCDIR_OLSRD)"
endif

uninstall:
ifneq ($(DOCDIR_OLSRD),)
		rm -f "$(DOCDIR_OLSRD)/README_DYN_GW"
		rmdir -p --ignore-fail-on-non-empty "$(DOCDIR_OLSRD)"
endif
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== lib/dyn_gw_plain/Makefile ===
# The olsr.org Optimized Link-State Routing daemon (olsrd)
#
# (c) by the OLSR project
#
# See our Git repository to find out who worked on this file
# and thus is a copyright holder on it.
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_dyn_gw_plain
PLUGIN_VER =	0.4

TOPDIR = ../..
include $(TOPDIR)/Makefile.inc

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)
ifneq ($(DOCDIR_OLSRD),)
		mkdir -p "$(DOCDIR_OLSRD)"
		cp "README_DYN_GW_PLAIN" "$(DOCDIR_OLSRD)"
endif

uninstall:
ifneq ($(DOCDIR_OLSRD),)
		rm -f "$(DOCDIR_OLSRD)/README_DYN_GW_PLAIN"
		rmdir -p --ignore-fail-on-non-empty "$(DOCDIR_OLSRD)"
endif
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== lib/filtergw/Makefile ===
# The olsr.org Optimized Link-State Routing daemon(olsrd)
# Copyright (c) 2021, Nick Hainke <vincent@systemli.org>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# * Neither the name of olsr.org, olsrd nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Visit http://www.olsr.org for more information.
#
# If you find this software useful feel free to make a donation
# to the project. For more information see the website or contact
# the copyright holders.
#

OLSRD_PLUGIN =	true
PLUGIN_NAME =	olsrd_filtergw
PLUGIN_VER =	0.0.1

TOPDIR =	../..
include $(TOPDIR)/Makefile.inc

default_target: $(PLUGIN_FULLNAME)

$(PLUGIN_FULLNAME): $(OBJS) version-script.txt
ifeq ($(VERBOSE),0)
		@echo "[LD] $@"
endif
		$(MAKECMDPREFIX)$(CC) $(LDFLAGS) -o $(PLUGIN_FULLNAME) $(OBJS) $(LIBS)

install:	$(PLUGIN_FULLNAME)
		$(STRIP) $(PLUGIN_FULLNAME)
		$(INSTALL_LIB)

uninstall:
		$(UNINSTALL_LIB)

clean:
		rm -f $(OBJS) $(SRCS:%.c=%.d) $(PLUGIN_FULLNAME)

=== debian/changelog ===
olsrd (0.9.8-4) UNRELEASED; urgency=medium

  * fix libgps
  * fix compilation with gcc 14
  * cleanup filtergw plugin
  * fix build error with clang 16
  * rename avl to olsrd_avl
  * add debian packaging

 -- Opennet Initiative <dev@opennet-initiative.de>  Sun, 9 Oct 2024 07:30:34 +0200

olsrd (0.9.8-3) UNRELEASED; urgency=medium

  * update patch series, improved prefix and libdir patch

 -- Opennet Initiative <dev@opennet-initiative.de>  Sun, 10 Apr 2022 07:30:34 +0200

olsrd (0.9.8-2) UNRELEASED; urgency=medium

  * update patch series, re-introduce path patch

 -- Opennet Initiative <dev@opennet-initiative.de>  Sun, 10 Apr 2022 06:47:20 +0200

olsrd (0.9.8-1) UNRELEASED; urgency=medium

  * new release 0.9.8

 -- Opennet Initiative <dev@opennet-initiative.de>  Sun, 10 Apr 2022 06:03:05 +0200

olsrd (0.9.6.1-1) UNRELEASED; urgency=medium

  [ Nicolas Braud-Santoni ]
  * New upstream version 0.9.6.1
  * Update debian/watch

  [ Ondřej Nový ]
  * d/control: Deprecating priority extra as per policy 4.0.1
  * d/changelog: Remove trailing whitespaces
  * d/control: Remove trailing whitespaces

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Tue, 27 Mar 2018 08:11:51 +0200

olsrd (0.6.6.2-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Standards-Version: 3.9.5

 -- Roland Stigge <stigge@antcom.de>  Sun, 08 Jun 2014 20:54:01 +0200

olsrd (0.6.6.1-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Fri, 25 Oct 2013 20:01:53 +0200

olsrd (0.6.5.2-1~) experimental; urgency=low

  * New upstream release
  * remove patches that have been included or obsoleted upstream
  * update build process based on upstream changes

 -- Hans-Christoph Steiner <hans@eds.org>  Mon, 01 Apr 2013 22:39:25 -0700

olsrd (0.6.3-6) unstable; urgency=low

  * include upstream fix for brokenness on amd64 (Closes: #704025)

 -- Hans-Christoph Steiner <hans@eds.org>  Wed, 27 Mar 2013 14:46:23 -0700

olsrd (0.6.3-5) unstable; urgency=low

  * fixed build system so all hardening flags are applied
  * fixed some lintian warnings
  * make tas plugin build against Debian's lua rather than the lua sources
    that are included in the olsrd orig tarball

 -- Hans-Christoph Steiner <hans@eds.org>  Fri, 05 Oct 2012 17:38:02 -0400

olsrd (0.6.3-4) unstable; urgency=low

  * debian/rules: Drop OS=linux from the make call, fixing FTBFS on !linux,
    thanks to Evgeni Golov (Closes: #679761)

 -- Roland Stigge <stigge@antcom.de>  Fri, 06 Jul 2012 18:58:27 +0200

olsrd (0.6.3-3) unstable; urgency=low

  * update broken jsoninfo plugin with patches from upstream git
  * updated default config based on settings from funkfeuer and
    commotionwireless.net

 -- Hans-Christoph Steiner <hans@eds.org>  Sat, 30 Jun 2012 09:57:55 -0400

olsrd (0.6.3-2) unstable; urgency=low

  * Re-upload to unstable

 -- Roland Stigge <stigge@antcom.de>  Sun, 24 Jun 2012 18:00:24 +0200

olsrd (0.6.3-1) experimental; urgency=low

  * New upstream release
  * debian/control: Standards-Version: 3.9.3

 -- Roland Stigge <stigge@antcom.de>  Fri, 08 Jun 2012 12:30:36 +0200

olsrd (0.6.2-2) unstable; urgency=low

  * debian/control: Build-Depends: debhelper (>= 9) (Closes: #658330)
  * Integrated patches by Hans-Christoph Steiner:
    - Added olsrd-gui (Closes: #658329)
    - debian/control: Recommends: olsrd-plugins (Closes: #658557)
    - Fix *.d clean problem (Closes: #658559)
    - Added olsr_switch (Closes: #658560)
    - Fix conffile location to /etc/olsrd/olsrd.conf (Closes: #658561)

    Thanks Hans-Christoph!

 -- Roland Stigge <stigge@antcom.de>  Sun, 19 Feb 2012 16:14:34 +0100

olsrd (0.6.2-1) unstable; urgency=low

  * New upstream release (repackaged and cleaned from debian/ dir)
  * Adjusted patches to upstream tarball
  * Removing obsolete options LinkQualityDijkstraLimit and LinkQualityWinSize
    from default configuration file (Closes: #652690)

 -- Roland Stigge <stigge@antcom.de>  Sun, 01 Jan 2012 23:20:20 +0100

olsrd (0.6.1-5) unstable; urgency=low

  * dh style debian/rules
  * debian/compat: 9, exports dpkg-buildflags (Closes: #643472)

 -- Roland Stigge <stigge@antcom.de>  Sun, 02 Oct 2011 14:59:17 +0200

olsrd (0.6.1-4) unstable; urgency=low

  * Added debian/watch

 -- Roland Stigge <stigge@antcom.de>  Mon, 01 Aug 2011 21:54:18 +0200

olsrd (0.6.1-3) unstable; urgency=low

  * Added armv7l to arch list for -fPIC in make/Makefile.linux
    (Closes: #636205)

 -- Roland Stigge <stigge@antcom.de>  Mon, 01 Aug 2011 21:23:31 +0200

olsrd (0.6.1-2) unstable; urgency=low

  * Add patch to upstream to add mips and mips64 to -fPIC arch list
    (fixes FTBFS on mips*)

 -- Roland Stigge <stigge@antcom.de>  Sat, 07 May 2011 13:11:27 +0200

olsrd (0.6.1-1) unstable; urgency=low

  [ Holger Levsen ]
  * New upstream version with quite some fixes and new features, see upstream
    changelog for details. Quoting from there:
     Change in version number system. No more -rcX for release candidates and
     -rX for bugfix releases. In future bugfix releases or updates of plugins
     will increase the third digit of the version string while feature
     releases will increase the first and/or the second one.
  * Update package description, OLSR is no experimental protocol anymore.

  [ Roland Stigge ]
  * New maintainer (Closes: #612277)
  * Adjusted debian patches to work with 0.6.1
  * debian/control:
    - Standards-Version: 3.9.2
    - Build-Depends: debhelper (>=8)
  * Debian source format: 3.0 (quilt)
  * Included remaining plugins
  * New upstream version works with newer kernels (Closes: #605296)
  * New upstream version fixes memory leak (Closes: #605295)

 -- Roland Stigge <stigge@antcom.de>  Tue, 03 May 2011 15:30:56 +0200

olsrd (0.5.6-r8-1) unstable; urgency=low

  * New upstream version, the eighth maintenance release of 0.5.6, introducing
    options to set the source and destination IP of the OLSR packets and a


=== debian/control ===
Source: olsrd
Section: net
Priority: optional
Maintainer: Roland Stigge <stigge@antcom.de>
Uploaders: Hans-Christoph Steiner <hans@eds.org>
Build-Depends: debhelper (>= 9),
               bison,
               flex,
               pkg-config,
               libgps-dev,
               liblua50-dev | liblua5.2-dev
Standards-Version: 3.9.5
Homepage: http://olsr.org/
Vcs-Git: https://salsa.debian.org/debian/olsrd.git
Vcs-Browser: https://salsa.debian.org/debian/olsrd

Package: olsrd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: olsrd-plugins
Description: optimized link-state routing daemon (unik-olsrd)
 unik-olsrd is an implementation of the Optimized Link State Routing protocol
 for Mobile Ad-Hoc networks(MANET). The protocol is described in RFC3626. It
 is designed to be run as a standalone server process.
 .
 OLSR operates as a table driven, proactive protocol, i.e., it exchanges
 topology information with other nodes of the network regularly. It is
 developed to work independently from other protocols. Likewise, OLSR makes no
 assumptions about the underlying link-layer.

Package: olsrd-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, olsrd (= ${binary:Version})
Description: various plugins to enhance olsrd
 olsrd is an implementation of the Optimized Link State Routing protocol
 for Mobile Ad-Hoc networks(MANET)
 .
 The following plugins are available:
 .
  * httpinfo      - tiny webserver for information purposes
  * dyn_gw        - dynamically announce uplinks
  * dot_draw      - generates output (over a TCP socket) in the dot format
  * secure        - secure OLSR routing with a shared key
  * nameservice   - announce hostnames and dns servers
  * bmf           - basic multicast forwarding
  * quagga        - import external routes from quagga
  * txtinfo       - display information about the OSLR node
 .
 The following plugins are also included, even though experimental and demo
 plugins:
 .
  * pgraph        - performance graph
  * watchdog      - detection of olsrd freeze
  * tas           - tiny application server
  * mini          - minimal example plugin (demo)
  * dyn_gw_plain  - dyn_gw without ping/libthread
  * arprefresh    - optimize kernel arp cache from olsr UDP sniffing
  * mdnsp         - multicast DNS via OLSR mesh network
  * p2pd          - distribute P2P Discovery messages

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export ETCDIR=/etc/olsrd
export LIBDIR=/lib/olsrd
export prefix=/usr

%:
	dh $@

override_dh_auto_build:
	$(MAKE) DEBUG=0 VERBOSE=1 build_all
	$(MAKE) -C src/olsr_switch

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) distclean

override_dh_auto_install:
	$(MAKE) VERBOSE=1 STRIP=: DESTDIR=$(CURDIR)/debian/olsrd \
		prefix=/usr libdir=/usr/lib/olsrd install
	$(MAKE) VERBOSE=1 STRIP=: DESTDIR=$(CURDIR)/debian/olsrd-plugins \
		prefix=/usr libdir=/usr/lib/olsrd libs_install
	install -d $(CURDIR)/debian/olsrd/usr/sbin/
	install -p -m0755 files/olsrd-adhoc-setup $(CURDIR)/debian/olsrd/usr/sbin/
	install -d $(CURDIR)/debian/olsrd/usr/bin/
	install -p -m0755 olsr_switch $(CURDIR)/debian/olsrd/usr/bin/
	install -d $(CURDIR)/debian/olsrd/usr/share/man/man8
	install -p -m0644 files/olsr_switch.8.gz \
		$(CURDIR)/debian/olsrd/usr/share/man/man8
	install -d $(CURDIR)/debian/olsrd/usr/share/doc/olsrd/examples
	install -p -m0644 files/olsrd.conf.[a-z]* \
		$(CURDIR)/debian/olsrd/usr/share/doc/olsrd/examples
# provide better default config
	install -p -m0644 $(CURDIR)/debian/olsrd.conf \
		$(CURDIR)/debian/olsrd/etc/olsrd/olsrd.conf
	install -p -m0644 $(CURDIR)/debian/olsrd-default \
		$(CURDIR)/debian/olsrd/etc/default/olsrd

override_dh_compress:
	# compress, but don't compress README_NAMESERVICE, for consistency reasons
	dh_compress -XREADME_NAMESERVICE -XREADME_BMF

=== debian/watch ===
version=3
http://www.olsr.org/releases/0.9/ olsrd-([\d\.]+)\.tar\.gz
